// ask.c

// minor update - 1 Sept, 2008 - extend HELP inputs to '/?' or '/h'
// does nothing but output a prompt, if one is given on the command line,
// waits for a character input
// then exits with ERRORLEVEL 1 if 'Y' or 'y' entered,
// else exits with ERRORLEVEL 0 for all other characters
// note: will accept redirected, like c:\>ask < yes.txt
// geoff r. mclane - July 13, 2006
// This some 40KB executable replaces my 16 bit 233 bytes COM file
// ===============================================================

#undef  _USE_WINDOWS
#define  _USE_KBHIT

#ifdef   _USE_KBHIT
#undef   _USE_WINDOWS
#endif // #ifdef _USE_KBHIT

#pragma warning( disable:4996 )

#ifdef   _USE_WINDOWS
#include <windows.h>
#include <io.h>
#endif // _USE_WINDOWS

#include <stdlib.h>  // toupper
#include <stdio.h>   // fflush
#include <conio.h>   // _getch
#include <ctype.h>   // toupper
#include <string.h>  // strcmpi


// try _kbhit
// Return Value
// _kbhit returns a nonzero value if a key has been pressed. Otherwise, it returns 0.

int wait_kbd( void )
{
   while( _kbhit() == 0 ) {
      _sleep(55);
   }
   return _getch();
}
 int verbal = 0;

int main( int argc, char * * argv )
{
   int   chr;
   int iret = 0;
   char * arg;
   int   argcnt = 0;
#ifdef   _USE_WINDOWS
   char buf[264];
   HANDLE h; // = GetStdHandle(STD_INPUT_HANDLE);
   int res;
#endif // _USE_WINDOWS
   // fflush(stdin); CAN NOT DO THIS if < yes.txt to be used
   if( argc > 1 ) {
      int i;
      /* preprcess arguments looking for HELP indication */
      for( i = 1; i < argc; i++ ) {
         arg = argv[i];
         if(( strcmpi(arg, "-?") == 0 )||
            ( strcmpi(arg, "-h") == 0 )||
            ( strcmpi(arg, "--help") == 0 )||
            ( strcmpi(arg, "/?") == 0) ||
            ( strcmpi(arg, "/h") == 0) )
         {
            printf( "Brief Help on Usage - " __DATE__ " " __TIME__ "\n" );
            printf( "%s [prompt]\n", argv[0] );
            printf( " If 'Y' input, errorexit set to 1\n" );
            printf( " Else all other input, errorexit 0\n" );
            exit(0);
         } else if( strcmpi(arg, "-v") == 0 ) {
            verbal = 1;
         }
      }
      for( i = 1; i < argc; i++ ) {
         arg = argv[i];
         /* skip any -v command */
         if (strcmpi(arg, "-v")) {
            printf( arg );
            printf( " " );
            argcnt++;
         }
      }
   }
#ifdef   _USE_WINDOWS
   // this needs windows.h
   res = feof(stdin);
   h = GetStdHandle(STD_INPUT_HANDLE); 
   //fread( buf, 1, 1, h );
   res = _read((int)h, buf, 1);
   if( res == -1 ) {
      //chr = toupper(_getch());
      chr = toupper(fgetc( stdin ));
   } else {
      chr = toupper(buf[0]);
   }
#else // !_USE_WINDOWS
#ifdef   _USE_KBHIT
   chr = toupper(wait_kbd());
   if( argc > 1 ) {
      if( chr == 'Y' ) {
         printf( "Yes" );
      } else {
         printf( "No" );
      }
   }
#else // !_USE_KBHIT
   if( feof(stdin) ) {
      chr = toupper(_getch());
   } else {
      chr = toupper(fgetc( stdin ));
   }
   //chr = toupper(getchar());
   //chr = toupper(fgetc( stdin ));
   //chr = toupper(getc( stdin ));
#endif   // _USE_KBHIT function
#endif // _USE_WINDOWS y/n
   fflush(stdin);
   if(chr == 'Y') {
      iret = 1;
   }
   if( argcnt ) {
      printf( "\n" );
   }
   if(verbal)
      printf( "ERRORLEVEL = %d\n", iret );

   return iret;
}

// eof - ask.c
